/*******************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2010 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://freeadhocudf.org> eMail <help@freeadhocudf.org>
 *   
 * this file contains declarations of all new functions from FreeAdhocUDF
 * from version adhoc20101111
 * use from FireBird 2.0 - possibility to return NULL
 *  
 * if you use this declarations in a non UTF-8 or UNICODE_FSS database 
 *		the max lenght of CSTRING is 32766 (1 Byte per character)
 * if you use this declarations in a InterBase UNICODE_FSS database 
 *		the max lenght of CSTRING is 10922 (3 Byts per character)
 * if you use this declarations in a InterBase or FireBird UTF-8 database 
 *		the max lenght of CSTRING is 8191 (max 4 Byts per character)
 * All declarations in this file are set to CSTRING(8191)
 * if you want to use one UDF more times in one piped string or one SQL, 
 * the sum of CSTRING of the used UDF doesn't grow over the max of your database
 *
 * Functions in group and alphabetical order
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*******************************************************************************/

SET SQL DIALECT 3;

/******************************************************************************/
/****                User Defined Functions - String Functions             ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_DSQM
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'dsqm' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                User Defined Functions - Math Functions               ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_RAPPENRUNDUNG
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'rappenrundung' MODULE_NAME 'FreeAdhocUDF';
 
/******************************************************************************/
/****                 User Defined Functions: Date and Time                ****/
/******************************************************************************/

/******************************************************************************/
/****                User Defined Functions - BLOb Functions               ****/
/******************************************************************************/

/******************************************************************************/
/****                   User Defined Functions - other functions           ****/
/******************************************************************************/

/******************************************************************************/
/****                   User Defined Functions - UTF-8 functions           ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION U_MONTHLONG
    TIMESTAMP NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_monthlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_monthshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWLONG
    TIMESTAMP NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_dowlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_dowshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DATE2STRLANG
    TIMESTAMP NULL,
    CSTRING(255) NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_date2strlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_monthlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_monthshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_dowlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_dowshortlang' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2010-11-06 */
